#include "stdafx.h"
#include "Rootfly.h"
#include "RootflyDlg.h"

////////////////////////////////////////////////////////////////////////
// ModeHandlerMODE_STARTINGMOVEALL

void ModeHandlerMODE_STARTINGMOVEALL::OnMouseMove(UINT nFlags, CPoint point2)
{
  //no functionality
}

void ModeHandlerMODE_STARTINGMOVEALL::OnLButtonDown(UINT nFlags, CPoint point)
{
  RPoint pt = m_dlg->m_converter.ClientToImage( point );
  //preserve the starting point of the move all
  m_dlg->m_controller.C_SetShowRootID(false); //fix clipping error
  m_dlg->m_last_mouse_move_point = CPoint(pt.x, pt.y);
  m_dlg->SetMode(MODE_MOVINGALLROOTS);
}

void ModeHandlerMODE_STARTINGMOVEALL::OnLButtonDblClk(UINT nFlags, CPoint point)
{
  //no functionality
}

void ModeHandlerMODE_STARTINGMOVEALL::OnRButtonDown(UINT nFlags, CPoint point)
{
  //no functionality
}

CString ModeHandlerMODE_STARTINGMOVEALL::GetStatusText()
{
  return "Left click to begin moving all roots";
}

void ModeHandlerMODE_MOVINGSINGLEROOT::OnMouseMove(UINT nFlags, CPoint cpoint)
{
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  RPoint point = m_dlg->m_converter.ClientToImage( CPoint(cpoint.x,cpoint.y),root->GetPrimaryWindow());
  CString temp;
  CPoint last = m_dlg->m_last_mouse_move_point;
  //get session number
  m_dlg->m_edit_session.GetWindowText(temp);
  int session = atoi(temp);		
  m_dlg->m_controller.C_MoveRootSess( m_dlg->m_selected_root_id, session, point.x - last.x, point.y - last.y );   
  //update the new old point
  m_dlg->m_last_mouse_move_point = CPoint( point.x, point.y );
  m_dlg->ReDraw(1,0);
}

CString ModeHandlerMODE_MOVINGSINGLEROOT::GetStatusText()
{
  CString str;
  str += _T("Moving root, left click to finish");
  return str;
}

void ModeHandlerMODE_MOVINGSINGLEROOT::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	// no functionality
}

void ModeHandlerMODE_MOVINGSINGLEROOT::OnLButtonDown(UINT nFlags, CPoint point)
{
  //finished moving root
  m_dlg->SetMode(MODE_IMAGEDISPLAYED);
  if (m_dlg->m_checkbox_show_root_ids.GetCheck() == BST_CHECKED)
  {
    m_dlg->m_controller.C_SetShowRootID(true);
  }
  m_dlg->ReDraw(1,0);
}

void ModeHandlerMODE_MOVINGSINGLEROOT::OnRButtonDown(UINT nFlags, CPoint point)
{
	// no functionality
}

//Group 2
//MODE_MOVINGALLROOTS
void ModeHandlerMODE_MOVINGALLROOTS::OnMouseMove(UINT nFlags, CPoint point2) 
{
  RPoint point = m_dlg->m_converter.ClientToImage( point2 );

  int window = m_dlg->m_app_data->GetWindow();
  CPoint last = m_dlg->m_last_mouse_move_point;

  //if (point.y == 507)
	//m_dlg->m_controller.C_MoveRootsInWindow(window, point.x - last.x, abs(point.y - last.y));
  //else

	m_dlg->m_controller.C_MoveRootsInWindow(window, point.x - last.x, point.y - last.y);    

  //update the new old point
  m_dlg->m_last_mouse_move_point = CPoint( point.x, point.y );
  m_dlg->ReDraw(1,0);
}

void ModeHandlerMODE_MOVINGALLROOTS::OnLButtonDown(UINT nFlags, CPoint point) 
{
  //finished with move all
  m_dlg->SetMode(MODE_IMAGEDISPLAYED);
  if (m_dlg->m_checkbox_show_root_ids.GetCheck() == BST_CHECKED)
  {
    m_dlg->m_controller.C_SetShowRootID(true);
  }
  m_dlg->ReDraw(1,0);    
}

void ModeHandlerMODE_MOVINGALLROOTS::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
}

void ModeHandlerMODE_MOVINGALLROOTS::OnRButtonDown(UINT nFlags, CPoint point) 
{
}

CString ModeHandlerMODE_MOVINGALLROOTS::GetStatusText() 
{
  CString str;
  str += _T("Moving roots, left click to finish");
  return str;
}


//MODE_NOFILELOADED
void ModeHandlerMODE_NOFILELOADED::OnMouseMove(UINT nFlags, CPoint point) 
{
}
void ModeHandlerMODE_NOFILELOADED::OnLButtonDown(UINT nFlags, CPoint point) 
{
}
void ModeHandlerMODE_NOFILELOADED::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
}
void ModeHandlerMODE_NOFILELOADED::OnRButtonDown(UINT nFlags, CPoint point) 
{
}
CString ModeHandlerMODE_NOFILELOADED::GetStatusText() 
{ 
  CString str;
  str += _T("To begin, choose File->New or File->Open");
  return str; 
}

// group 3
void ModeHandlerMODE_DRAWINGNEWROOT::OnMouseMove(UINT nFlags, CPoint point) 
{
  SetCursor(m_dlg->m_cur_pen);
  m_dlg->ReDraw( 1, 0 );
}

void ModeHandlerMODE_DRAWINGNEWROOT::OnLButtonDown(UINT nFlags, CPoint point) 
{
  m_dlg->LeftClickWhileDrawingNewRoot( m_dlg->m_converter.ClientToImage( point ) ); 
}

void ModeHandlerMODE_DRAWINGNEWROOT::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
  RDiameter *rdm;
  RPoint conv_point;
  conv_point = m_dlg->m_converter.ClientToImage(point);
  while ( m_dlg->m_current_root_being_drawn.GetAllPoints()->size() < 2 ) 
        m_dlg->LeftClickWhileDrawingNewRoot( m_dlg->m_converter.ClientToImage( point ) );
      rdm = m_dlg->m_current_root_being_drawn.CreateDiameter();
      rdm->r_point.x = conv_point.x;
      rdm->r_point.y = conv_point.y;
      rdm->radius = 8;
      rdm->r_point.window = m_dlg->m_app_data->GetWindow();
      m_dlg->SetMode(MODE_LOCATINGDIAMETER); 
}

void ModeHandlerMODE_DRAWINGNEWROOT::OnRButtonDown(UINT nFlags, CPoint point) 
{
  ;
}

CString ModeHandlerMODE_DRAWINGNEWROOT::GetStatusText() 
{ 
  return "Left click to add point, double click to end root"; 
}


//Group 7
void ModeHandlerMODE_LOCATINGDIAMETER::OnMouseMove(UINT nFlags, CPoint point) 
{
  RPoint pt = m_dlg->m_converter.ClientToImage( point);
  RDiameter *rdm = m_dlg->m_current_root_being_drawn.GetDiameter(0);
  RPoint temp = m_dlg->FindNearestPointOnRoot( pt, m_dlg->m_current_root_being_drawn);    
  rdm->r_point.x = temp.x;
  rdm->r_point.y = temp.y;
  rdm->r_point.window = temp.window; 
  rdm->radius = 8;    
  m_dlg->ReDraw(1, 0);   
}

void ModeHandlerMODE_LOCATINGDIAMETER::OnLButtonDown(UINT nFlags, CPoint point) 
{
  m_dlg->SetMode(MODE_SIZINGDIAMETER);       
  m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_LOCATINGDIAMETER::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
  std::vector<RPoint>::const_iterator r_iter;
  RDiameter *rd2;
  RPoint *rpt;  
  RootInstance *r_inst;
  const Root *root;  
  const Tube *tube;
  const std::vector<RPoint> *line;  
  
  RPoint conv_point, temp;
  CRect main;
  RDiameter *rdm;
  rdm = m_dlg->m_current_root_being_drawn.GetDiameter(0);
      temp = m_dlg->FindNearestPointOnRoot( conv_point, m_dlg->m_current_root_being_drawn );
      rdm->r_point.x = temp.x;
      rdm->r_point.y = temp.y;
      rdm->r_point.window = temp.window;
      rdm->radius = 8;
      
      tube = m_dlg->m_exp_data->GetTube( m_dlg->m_app_data->GetTube() );
      if ( tube == NULL ) tube = m_dlg->m_controller.C_CreateTube(m_dlg->m_app_data->GetTube());
      line = m_dlg->m_current_root_being_drawn.GetAllPoints();    
      assert(line->size() > 0);
      if (line->size() == 0)  return;
      root = m_dlg->m_controller.C_CreateRoot( line->at(0).window );    
      r_inst = m_dlg->m_controller.C_CreateRootInstance( root->GetID() );
      assert( r_inst );    
      for ( r_iter = line->begin(); r_iter != line->end(); r_iter++ )
      {
        rpt = r_inst->CreatePoint();
		*rpt = *r_iter;
//        rpt->x = r_iter->x;
//        rpt->y = r_iter->y;
//        rpt->window = r_iter->window;     
      }
      rd2 = m_dlg->m_controller.C_CreateDiameter( root->GetID() );
      *rd2 = *rdm;
//      rd2->r_point.x = rdm->r_point.x;
//      rd2->r_point.y = rdm->r_point.y;
//      rd2->r_point.window = rdm->r_point.window;
//      rd2->radius = rdm->radius;
      
      // sets the default condition code for the root
      m_dlg->SetConditionDefault(root);
      
      m_dlg->SetMode(MODE_IMAGEDISPLAYED);
      m_dlg->m_current_root_being_drawn.ClearAll();
      m_dlg->ReDraw(1, 0);
}
void ModeHandlerMODE_LOCATINGDIAMETER::OnRButtonDown(UINT nFlags, CPoint point) 
{
  //empty
}
CString ModeHandlerMODE_LOCATINGDIAMETER::GetStatusText() 
{
  return "Left click to place diameter";
	
}

void ModeHandlerMODE_REPOSITIONDIAMETER::OnMouseMove(UINT nFlags, CPoint point2) {
   
   RPoint point = m_dlg->m_converter.ClientToImage( point2 );

  SetCursor(m_dlg->m_cur_closedhand);
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  RPoint temp = m_dlg->FindNearestPointOnRoot(point, *inst);
  if ( temp.x < 0 || temp.y < 0) return;
  double dist = sqrt(pow((temp.x - point.x),2) + pow((temp.y - point.y),2));       
  if ( dist > 1.0 )  //keeps the diameter from walking around
  {
    m_dlg->m_controller.C_MoveDiameter(0, m_dlg->m_selected_root_id, temp);   
  } 
  m_dlg->ReDraw(1, 0);
 }

 void ModeHandlerMODE_REPOSITIONDIAMETER::OnLButtonDown(UINT nFlags, CPoint point) {
    m_dlg->SetMode(MODE_ROOTSELECTED);          
    m_dlg->ReDraw(1, 0);

 }
 void ModeHandlerMODE_REPOSITIONDIAMETER::OnLButtonDblClk(UINT nFlags, CPoint point) {
 
 }
 void ModeHandlerMODE_REPOSITIONDIAMETER::OnRButtonDown(UINT nFlags, CPoint point) {
 
 }
 CString ModeHandlerMODE_REPOSITIONDIAMETER::GetStatusText() { 
   return "Moving diameter, left click to finish"; 
 }


// group 4 MODE_ROOTSELECTED
void ModeHandlerMODE_ROOTSELECTED::OnMouseMove(UINT nFlags, CPoint point_client)
{
  RPoint point = m_dlg->m_converter.ClientToImage( point_client);
  RDiameter nearest_point;
  nearest_point.radius = -1;
  m_dlg->FindNearestPoint( point.x, point.y, &nearest_point);   
  if ( nearest_point.radius < 0 )        
  {
    m_dlg->m_over_root = false;      
    m_dlg->UpdateStatusText();
  }
  else
  {
    m_dlg->m_over_root = true;   
    m_dlg->UpdateStatusText();
  }
  m_dlg->m_selected_index = m_dlg->GetSelectedIndex(CPoint( point.x, point.y ));    
  if ( m_dlg->m_selected_index == m_dlg->RESIZING_DIAMETER_SELECTED )
  {
    SetCursor(m_dlg->m_cur_sizens);
    m_dlg->UpdateStatusText();
  }
  else if ( m_dlg->m_selected_index == m_dlg->DIAMETER_SELECTED )
  {
    SetCursor(m_dlg->m_cur_openhand);
    m_dlg->UpdateStatusText();
  }
  else if ( m_dlg->m_selected_index == m_dlg->NOTHING_SELECTED )
  {
  }
  else if ( m_dlg->m_selected_index >= 0 )
  {
    SetCursor(m_dlg->m_cur_sizeall); 
    m_dlg->UpdateStatusText();
  }
}

void ModeHandlerMODE_ROOTSELECTED::OnLButtonDown(UINT nFlags, CPoint point_client)
{
  RPoint point = m_dlg->m_converter.ClientToImage( point_client);
  RDiameter nearest_point;
  m_dlg->FindNearestPoint( point.x, point.y, &nearest_point);      
  int selected_diameter = m_dlg->FindNearestDiameter(point.x, point.y);
  // Check to see if another root has been selected and change selected ID
  {
    bool clicked_point_of_selected_root = nearest_point.radius >= 0 && nearest_point.r_point.window == m_dlg->m_selected_root_id;
    bool clicked_diameter_of_selected_root = selected_diameter >= 0 && selected_diameter == m_dlg->m_selected_root_id;
    bool clicked_point_of_another_root = nearest_point.radius >= 0 && nearest_point.r_point.window != m_dlg->m_selected_root_id;
    bool clicked_diameter_of_another_root = selected_diameter >= 0 && selected_diameter != m_dlg->m_selected_root_id;
    if (!clicked_point_of_selected_root && !clicked_diameter_of_selected_root)
    {
      if (clicked_diameter_of_another_root) 
      {
        m_dlg->m_selected_root_id = selected_diameter;
        m_dlg->ReDraw(1,0);
        return;
      }
      else if (clicked_point_of_another_root) 
      {
        m_dlg->m_selected_root_id = nearest_point.r_point.window;  
        m_dlg->ReDraw(1,0);
        return;
      }
    }
  }
  // -1 means not over an interactive area of the root
  // -2 means over the diameter move area   (now moving the diameter)
  // -3 means over the diameter resize area (now resizing the diameter)   
  // all other indexes refer to points along the root (now moving a point)
  if (m_dlg->m_selected_index == m_dlg->RESIZING_DIAMETER_SELECTED) // -3
  {
    SetCursor(m_dlg->m_cur_sizens);
    m_dlg->SetMode(MODE_RESIZINGDIAMETER);
  }
  else if ( m_dlg->m_selected_index == m_dlg->DIAMETER_SELECTED )  // -2
  {
    SetCursor(m_dlg->m_cur_closedhand);
    m_dlg->SetMode(MODE_REPOSITIONDIAMETER);
  }
  else if ( m_dlg->m_selected_index >= 0 )
  {
    SetCursor(m_dlg->m_cur_sizeall);
    m_dlg->SetMode(MODE_MOVINGRPOINT); 
    m_dlg->UpdateDiameterPositionRatio();
  }
  else if (!m_dlg->m_over_root) 
  {
    // clicked off of root, it is no longer selected
    m_dlg->SetMode(MODE_IMAGEDISPLAYED);      
    m_dlg->m_selected_root_id = -1;
    m_dlg->m_selected_index = -1;       
    m_dlg->ReDraw(1, 0);
  }
  else
  {
    //preserve the starting point of the move 
    m_dlg->m_controller.C_SetShowRootID(false); //fix clipping error
    m_dlg->m_last_mouse_move_point = CPoint(point.x, point.y);
    m_dlg->SetMode(MODE_MOVINGSINGLEROOT);
  }
}

void ModeHandlerMODE_ROOTSELECTED::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
  //empty, does nothing
}

void ModeHandlerMODE_ROOTSELECTED::OnRButtonDown(UINT nFlags, CPoint point) 
{
   if ( m_dlg->m_over_root )
   {
     // show context menu
     CMenu menu;
     menu.LoadMenu(IDR_MENU_CONTEXT);
     CMenu* popup;
     if( m_dlg->m_selected_index > -1 )  //Delete Button if Point clicked
     { 
       popup = menu.GetSubMenu(0);  
     }
     else   //Add Point Button if other part of root clicked
     {  
       const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
       assert(tube);  if (!tube)  return;
       const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
       assert(root);  if (!root)  return;
       const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
       assert(inst);  if (!inst)  return;
       popup = menu.GetSubMenu(1);  
       m_dlg->temporary_point_to_add = m_dlg->m_converter.ClientToImage(point);
       m_dlg->FindNearestPointOnRootSeg(m_dlg->temporary_point_to_add, *inst, &(m_dlg->section_start_point_index));  //Get segment to add point on
     }
     assert(popup != NULL);
     CPoint pt = point;
     m_dlg->ClientToScreen(&pt);
     popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, m_dlg );
     m_dlg->SetMode(MODE_IMAGEDISPLAYED); //keeps it in the right mode after closing the menu
   }
   return;
}

CString ModeHandlerMODE_ROOTSELECTED::GetStatusText() 
{ 
  CString str;
  switch( m_dlg->m_selected_index )
  {
    case -3:
      str+= _T("Left click to resize this diameter");
      break;
    case -2:
      str+= _T("Left click to move this diameter");
      break;
    case -1:
      if(m_dlg->m_over_root) str += _T("Left click to move root or right click to add a new point");
      else str += _T("Ready to modify root");
      break;
    default:
      str += _T("Left click to move this point, right click to delete");
  }
  return str;
}


// group 6
void ModeHandlerMODE_MOVINGRPOINT::OnMouseMove(UINT nFlags, CPoint point) 
{
  SetCursor(m_dlg->m_cur_sizeall);
  RPoint tempdiam;
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  const RPoint oldpoint = *( inst->GetPoint(m_dlg->m_selected_index) );
  RPoint pt = m_dlg->m_converter.ClientToImage(CPoint(point.x,point.y),root->GetPrimaryWindow());

  m_dlg->m_controller.C_MovePoint( m_dlg->m_selected_index, m_dlg->m_selected_root_id, pt.x, pt.y );
  m_dlg->m_controller.C_ChangeWindowOfPoint( m_dlg->m_selected_index, m_dlg->m_selected_root_id, pt.window );

  // check if diameter is on relevant root segment, if it isn't, do nothing.
  if ( (m_dlg->section_start_point_index == m_dlg->m_selected_index) || (m_dlg->section_start_point_index == (m_dlg->m_selected_index-1) ) )
  {
    //get other point of segment
    const RPoint* otherpoint; 
    //get new diameter position if neccesary
    if ( m_dlg->section_start_point_index == m_dlg->m_selected_index )
    {
      otherpoint = inst->GetPoint(m_dlg->section_start_point_index + 1);
      tempdiam.x = (double)pt.x - ( (double)pt.x - (double)otherpoint->x ) * m_dlg->diameter_position_ratio;
      tempdiam.y = (double)pt.y - ( (double)pt.y - (double)otherpoint->y ) * m_dlg->diameter_position_ratio;
    }
    else
    {
      otherpoint = inst->GetPoint(m_dlg->section_start_point_index);
      tempdiam.x = (double)pt.x - ( (double)pt.x - (double)otherpoint->x ) * (1 - m_dlg->diameter_position_ratio);
      tempdiam.y = (double)pt.y - ( (double)pt.y - (double)otherpoint->y ) * (1 - m_dlg->diameter_position_ratio);
    }
    tempdiam.window = diam->r_point.window;
    m_dlg->m_controller.C_MoveDiameter(0, m_dlg->m_selected_root_id, tempdiam);
  }
  m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_MOVINGRPOINT::OnLButtonDown(UINT nFlags, CPoint point) 
{
  m_dlg->SetMode(MODE_ROOTSELECTED);          
  m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_MOVINGRPOINT::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// does nothing
}

void ModeHandlerMODE_MOVINGRPOINT::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// does nothing
}

CString ModeHandlerMODE_MOVINGRPOINT::GetStatusText() 
{
	return "Moving point, left click to finish"; 
}


//
void ModeHandlerMODE_EXTENDINGENDPOINT::OnMouseMove(UINT nFlags, CPoint point) 
{
  RPoint pt = m_dlg->m_converter.ClientToImage(point);
  CPoint head = m_dlg->m_converter.ImageToClient(*(m_dlg->m_current_root_being_drawn.GetPoint(0)));
  const vector<RPoint> *points = m_dlg->m_current_root_being_drawn.GetAllPoints();    
  CPoint tail = m_dlg->m_converter.ImageToClient(*(m_dlg->m_current_root_being_drawn.GetPoint(points->size()-1)));
  CPoint c_pt = m_dlg->m_converter.ImageToClient(pt);

  double delta_x, delta_y;
  delta_x = c_pt.x - head.x;
  delta_y = c_pt.y - head.y;
  double distance_to_head = delta_x * delta_x + delta_y * delta_y;
  delta_x = c_pt.x - tail.x;
  delta_y = c_pt.y - tail.y;
  double distance_to_tail = delta_x * delta_x + delta_y * delta_y;
  m_dlg->m_extending_from_tail = (distance_to_tail < distance_to_head) ? true : false;
  m_dlg->m_extending_from_head = (distance_to_tail < distance_to_head) ? false : true;
  m_dlg->ReDraw(1,0);
}
void ModeHandlerMODE_EXTENDINGENDPOINT::OnLButtonDown(UINT nFlags, CPoint point) 
{
  RPoint pt = m_dlg->m_converter.ClientToImage(point);
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube() );
  assert(tube); if (!tube) return;
  const vector<Root> *roots = tube->GetAllRoots();
  assert(roots); if (!roots) return;;    
  for (int i = 0; i < roots->size(); i++)
  {
    const Root& root = roots->at(i);
    int id = root.GetID();
    if (id == m_dlg->m_selected_root_id)
    {
      const RootInstance *inst = root.GetRootInstance(m_dlg->m_app_data->GetSession());  
      if (!inst) return;
      const std::vector<RPoint> *old_line = inst->GetAllPoints();
      RPoint *rpt = m_dlg->m_controller.C_CreatePoint(id);
      if (m_dlg->m_extending_from_tail)
      {
        *rpt = pt;
        m_dlg->m_extending_from_tail = false;
      }
      if (m_dlg->m_extending_from_head)
      {
        for (int j = old_line->size(); j >= 0; j--)
        {
          RPoint temp_point = (j>0) ? old_line->at(j-1) : pt;
          m_dlg->m_controller.C_MovePoint(j, id, temp_point.x, temp_point.y);
          m_dlg->m_controller.C_ChangeWindowOfPoint(j, id, temp_point.window);
        }
        m_dlg->m_extending_from_head = false;
      }
      break;
    }
  } 
  m_dlg->m_current_root_being_drawn.ClearAll();
  m_dlg->SetMode(MODE_ROOTSELECTED);
  m_dlg->ReDraw(1,0);
}
void ModeHandlerMODE_EXTENDINGENDPOINT::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	//Double Click not used by EXTENDINGENDPOINT
}
void ModeHandlerMODE_EXTENDINGENDPOINT::OnRButtonDown(UINT nFlags, CPoint point) 
{
    m_dlg->SetMode(MODE_ROOTSELECTED);
    m_dlg->m_extending_from_tail = false;
    m_dlg->m_extending_from_head = false;
    m_dlg->m_current_root_being_drawn.ClearAll();
    m_dlg->ReDraw(1,0);
}
CString ModeHandlerMODE_EXTENDINGENDPOINT::GetStatusText() 
{ 
  return "Left click to extend endpoint";
}


void ModeHandlerMODE_IMAGEDISPLAYED::OnMouseMove(UINT nFlags, CPoint point) 
{
  RPoint pt = m_dlg->m_converter.ClientToImage(point);

  int tempRootID;	
  RDiameter nearest_point;
  m_dlg->FindNearestPoint( pt.x, pt.y, &nearest_point);      
  int diameter_selected = m_dlg->FindNearestDiameter( pt.x, pt.y );
  if ( nearest_point.radius < 0 && diameter_selected < 0)
  {
    m_dlg->m_selected_root_id = -1;
    if ( m_dlg->m_over_root )
    {
      m_dlg->m_over_root = false; 
      m_dlg->ReDraw(1, 0);          
    }
  }
  else 
  { 
	  const Tube *tube = m_dlg->m_exp_data->GetTube( m_dlg->m_app_data->GetTube() );
	  if (!tube)  return;

    if (nearest_point.radius >= 0)
	  {
	    tempRootID = nearest_point.r_point.window;
	    const Root *root = tube->GetRoot(tempRootID);
	    if (!root)  return;
	    const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
	    if (!inst)  return;
	    if ((inst->IsAlive()) || (m_dlg->m_checkbox_show_dead_roots.GetCheck() == BST_CHECKED)) m_dlg->m_selected_root_id = nearest_point.r_point.window; 
	  }
    else
	  {
	    tempRootID = diameter_selected;
	    const Root *root = tube->GetRoot(tempRootID);
	    if (!root)  return;
	    const RootInstance *inst2 = root->GetRootInstance(m_dlg->m_app_data->GetSession());
	    if (!inst2)  return;
      if ((inst2->IsAlive()) || (m_dlg->m_checkbox_show_dead_roots.GetCheck() == BST_CHECKED)) m_dlg->m_selected_root_id =  diameter_selected;   
	  }
    
    if ( !m_dlg->m_over_root )
    {
	    m_dlg->m_over_root = true;
      m_dlg->ReDraw(1, 0);
    }
    else
    {
      m_dlg->ReDraw(1, 0);    
    }
  }
}
void ModeHandlerMODE_IMAGEDISPLAYED::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_dlg->m_over_root)
      {
        m_dlg->SetMode(MODE_ROOTSELECTED);            
        m_dlg->ReDraw(1, 0);
      }
}
void ModeHandlerMODE_IMAGEDISPLAYED::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// Is not used by this function
}
void ModeHandlerMODE_IMAGEDISPLAYED::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// Is not used by this function
}
CString ModeHandlerMODE_IMAGEDISPLAYED::GetStatusText() 
{ 
  return "Ready to annotate"; 
}

void ModeHandlerMODE_SIZINGDIAMETER::OnMouseMove(UINT nFlags, CPoint point)
{
  RPoint temp = m_dlg->m_converter.ClientToImage(point);
  RDiameter *rdm = m_dlg->m_current_root_being_drawn.GetDiameter(0);
  rdm->radius = sqrt( pow(( temp.x - rdm->r_point.x),2) + pow(( temp.y - rdm->r_point.y),2) ); 
  m_dlg->ReDraw(1, 0); 
}

void ModeHandlerMODE_SIZINGDIAMETER::OnLButtonDown(UINT nFlags, CPoint point2)
{
  RDiameter *rd = m_dlg->m_current_root_being_drawn.GetDiameter(0);
  const std::vector<RPoint> *line;  
  line = m_dlg->m_current_root_being_drawn.GetAllPoints();    
  if (line->size() == 0)  return;
  Root *root = m_dlg->m_controller.C_CreateRoot( line->at(0).window );    
  RootInstance *inst = m_dlg->m_controller.C_CreateRootInstance( root->GetID() );  
  RPoint *rpt;
  vector<RPoint>::const_iterator iter;
  for ( iter = line->begin(); iter != line->end(); iter++ )
  {
    rpt = inst->CreatePoint();
    rpt->x = iter->x;
    rpt->y = iter->y;
    rpt->window = iter->window;     
  }
  RDiameter *rd2 = m_dlg->m_controller.C_CreateDiameter( root->GetID() );
  rd2->r_point.x = rd->r_point.x;
  rd2->r_point.y = rd->r_point.y;
  rd2->r_point.window = rd->r_point.window;
  rd2->radius = rd->radius;

  // sets the default condition code for the root
  m_dlg->SetConditionDefault(root);
  m_dlg->m_selected_root_id = -1;
  m_dlg->SetMode(MODE_IMAGEDISPLAYED);
  m_dlg->m_current_root_being_drawn.ClearAll();
  m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_SIZINGDIAMETER::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	std::vector<RPoint>::const_iterator r_iter;
	const std::vector<RPoint> *line = m_dlg->m_current_root_being_drawn.GetAllPoints();
	RPoint *rpt;
	RPoint conv_point, temp = m_dlg->FindNearestPointOnRoot( conv_point, m_dlg->m_current_root_being_drawn );
	RDiameter *rdm = m_dlg->m_current_root_being_drawn.GetDiameter(0), *rd2;
	const Root *root = m_dlg->m_controller.C_CreateRoot( line->at(0).window );
	RootInstance *r_inst = m_dlg->m_controller.C_CreateRootInstance( root->GetID() );

	assert( r_inst );
    assert(line->size() > 0);
    if (line->size() == 0)  return;

    rdm->r_point.x = temp.x;
    rdm->r_point.y = temp.y;
    rdm->r_point.window = temp.window;
    rdm->radius = 8;
  
	for ( r_iter = line->begin(); r_iter != line->end(); r_iter++ )
    {
        rpt = r_inst->CreatePoint();
        rpt->x = r_iter->x;
        rpt->y = r_iter->y;
        rpt->window = r_iter->window;
    }
    rd2 = m_dlg->m_controller.C_CreateDiameter( root->GetID() );
	rd2 = rdm;
      
    // sets the default condition code for the root
    m_dlg->SetConditionDefault(root);
    m_dlg->SetMode(MODE_IMAGEDISPLAYED);
    m_dlg->m_current_root_being_drawn.ClearAll();
    m_dlg->ReDraw(1, 0);
}

void ModeHandlerMODE_SIZINGDIAMETER::OnRButtonDown(UINT nFlags, CPoint point)
{
}

CString ModeHandlerMODE_SIZINGDIAMETER::GetStatusText() 
{ 
  CString str;
  str += _T("Left click to set diameter size");
  return str; 
}

void ModeHandlerMODE_NOIMAGEDISPLAYED::OnMouseMove(UINT nFlags, CPoint point)
{
  //No functionality.
}
void ModeHandlerMODE_NOIMAGEDISPLAYED::OnLButtonDown(UINT nFlags, CPoint point)
{
  //No functionality.
}
void ModeHandlerMODE_NOIMAGEDISPLAYED::OnLButtonDblClk(UINT nFlags, CPoint point)
{
  //No functionality.
}
void ModeHandlerMODE_NOIMAGEDISPLAYED::OnRButtonDown(UINT nFlags, CPoint point)
{
  //No functionality.
}
CString ModeHandlerMODE_NOIMAGEDISPLAYED::GetStatusText()
{
  CString str;
  str += _T("No Image Displayed");
  return str; 
}

void ModeHandlerMODE_RESIZINGDIAMETER::OnMouseMove(UINT nFlags, CPoint point2)
{
  RPoint point = m_dlg->m_converter.ClientToImage( point2 );
  SetCursor(m_dlg->m_cur_sizens);    
  const Tube *tube = m_dlg->m_exp_data->GetTube(m_dlg->m_app_data->GetTube());
  assert(tube);  if (!tube)  return;
  const Root *root = tube->GetRoot(m_dlg->m_selected_root_id);
  assert(root);  if (!root)  return;
  const RootInstance *inst = root->GetRootInstance(m_dlg->m_app_data->GetSession());
  assert(inst);  if (!inst)  return;
  const RDiameter *diam = inst->GetDiameter(0);
  assert(diam);  if (!diam)  return;
  {        
    int delta_x, delta_y;        
    delta_x = diam->r_point.x - point.x;
    delta_y = diam->r_point.y - point.y;
    double new_radius = sqrt(pow(delta_x,2)+pow(delta_y,2));
    m_dlg->m_controller.C_ResizeDiameter(0, m_dlg->m_selected_root_id, new_radius);      
  }
  m_dlg->ReDraw(1,0);
}

void ModeHandlerMODE_RESIZINGDIAMETER::OnLButtonDown(UINT nFlags, CPoint point)
{
  m_dlg->SetMode(MODE_ROOTSELECTED);
    m_dlg->ReDraw(1,0);
}
void ModeHandlerMODE_RESIZINGDIAMETER::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	//NOP
}

void ModeHandlerMODE_RESIZINGDIAMETER::OnRButtonDown(UINT nFlags, CPoint point)
{
	//NOP
}

CString ModeHandlerMODE_RESIZINGDIAMETER::GetStatusText()
{
	return "Resizing diameter, left click to finish";
}
